from csst_common.data_manager import CsstMsFile

# DFS root directory
DFSROOT = "/share/dfs"
# output directory
dir_out = "/L1Pipeline/L1"

# filter = GV
sls_id = 16734
mbi_ids = [
    11512, 14521, 14044, 13870, 13300, 12772, 14470, 14254, 11797, 10981, 14455, 12808, 14296, 13684, 11941, 11857,
    13123, 13744, 12814, 14080, 14083, 11956, 14290, 13315, 13885, 14506, 10993, 13126, 12679, 13855, 13177, 14041,
    12979, 14293, 13165, 12667, 13174, 10810, 10822, 12856, 14518, 14641, 13141, 14029, 11887, 11524, 13795, 14266,
    13888, 13852, 13138, 12991, 11944, 14137, 14458, 14134, 13741, 12532, 14185, 13783, 14248, 14269, 13303, 12796,
    14626, 13162, 13687, 13180, 14146, 14149, 12769, 14509, 10825, 14191, 10978, 13786, 14371, 11845, 12799, 13798,
    8941, 13360, 14188, 12871, 13312
]

# input files
file_sls = CsstMsFile.from_l1id(id=sls_id, dir_out=dir_out, dfs_root=DFSROOT)
files_mbi = [CsstMsFile.from_l1id(id=mbi_id, dir_out=dir_out, dfs_root=DFSROOT) for mbi_id in mbi_ids]

from csst_ms_sls_mosaic.top_level_interface import do_mosaic
status, fr, covrate = do_mosaic(file_sls, files_mbi, logger=None, threshold=90)
# do_mosaic(file_sls, files_mbi, logger=None)

from csst_ms_sls_directimage.top_level_interface import sls_generate_direct_image
status, fr, _ = sls_generate_direct_image(file_sls, logger=None)

from csst_ms_sls_objextraction.top_level_interface import sls_objextraction_singleCCD
status, fr, _ = sls_objextraction_singleCCD(file_sls, logger=None)

from csst_ms_sls_sky.top_level_interface import sls_generate_direct_image
status, fr, _ = sls_generate_direct_image(file_sls, logger=None)

from csst_ms_sls_axe.top_level_interface import sls_axe_single
status, fr, _ = sls_axe_single(file_sls, logger=None)

from csst_ms_sls_cde.top_level_interface import cde_main
status, fr, _ = cde_main(file_sls, logger=None)

"""
输入的无缝光谱1级图像路径  file_sls.fpi()
对应的mosaic图像路径      file_sls.fpo(post="mosaic.fits")
对应的directimage图像路径 file_sls.fpo(post="dimg.fits")
对应的sky图像路径         file_sls.fpo(post="sky.fits")
对应的axe结果路径         file_sls.fpo(post="axe.fits")
对应的cde结果路径         file_sls.fpo(post="cde.fits")

convert to WCS:
from astropy.wcs import WCS
wcs = WCS(header=file_sls.header)
"""
